**Latest Tag Release**
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-Registry-Verification/wiki/xnfrctl-coverage-latesttag.svg)
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-Registry-Verification/wiki/xnfrctl-version-latesttag.svg)

**Develop**
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-Registry-Verification/wiki/xnfrctl-coverage-develop.svg)
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-Registry-Verification/wiki/xnfrctl-version-develop.svg)

# xNF Registry Control CLI

CLI to interact with the xNF Registry Asset.

## Description

The Control CLI currently focuses on:

1. Interaction with an OCI-Registry for login/logout and pull/push. 
2. Custom functionalities such as OCI spec pull (manifest command) or list registry
3. Extension to project-specific artifacts (Nephele) via golang interfaces
4. Lint of the descriptor syntax and the archive's structure and format.


## Getting Started

cmd: CLI commands using the Cobra framework which performs the E2E execution of the interaction with custom OCI artifacts and OCI-compatible registries. At this point, all of the code is completely generic to any OCI implementation thanks to root_cmd_config.go (see Nephele's HDAR for an example of extending it):
 - AddCorrectInspectorFunction to connect to the right AddCorrectInspector function which subsecuently provides the right implementations of the inspectors.
 - GetTemplateMapFunction to provide the right artifacts that are "createable".  

### Prerequisites

#### Software

Project built using Golang 1.22.

#### Hardware

No major requirements found. 1vCPU, 1GiB RAM

### Installation

1. Go auto formatting and linting. Execute before pushing to origin. It is automated in CI pipeline and will fail if not ok

```bash
go fmt $(go list ./... | grep -v /vendor/)
go vet $(go list ./... | grep -v /vendor/)
```

2. Test it

```bash
go test $(go list ./... | grep -v /vendor/) -v
```

3. Build it

```bash
GOOS=linux GARCH=amd64 CGO_ENABLED=0 go build -v -a -installsuffix cgo -o xnfrctl .
```

## Usage

### Locally

This is a CLI distributed as an standalone binary file

```bash
./xnfrctl --help
xNF Registry and Verification is a future-proof, full-fledged asset for Telco service storage, distribution and exposure
Smart Networks & Services R&D unit in Eviden (ATOS business).
Complete documentation is available at the repo

Usage:
  xnfrv [command]

Available Commands:
  create      Create an artifact
  help        Help about any command
  lint        Verifies syntax
  login       Log in to a remote registry
  logout      Log out to a remote registry
  ls          List all artifacts in a repository
  manifest    Pulls an OCI manifest. 
  package     Parent command to tar and untar commands
  pull        Pulls an OCI artifact from a remote registry
  push        Pushes a local artifact to a remote registry

Flags:
  -h, --help   help for xnfrv

Use "xnfrv [command] --help" for more information about a command.
```

Logs can be disable by adding a local .env with 

```text
# Check More options in the go-common/components/utils library
LOGS_DISCARD=True
LOG_LEVEL=DEBUG
```

Then run:
```bash
export $(grep -v '^#' .env | xargs)
``` 

### Production

A) Developers just need the executable to interact with the xNF Registry Asset.

B) Create docker image locally or pull the one generated by the CICD pipeline

```bash
# we need access to the full repo
cd ../../
docker build -t registry.atosresearch.eu:18467/xnfrctl:latest -f components/xnfr-ctl/install/dockerfile --progress plain  .
# adapt env vars from install/.env-tests
cd components/xnfr-ctl/
docker run registry.atosresearch.eu:18467/xnfrctl:latest --env-file install/.env-tests
```

## Contribution

Tech:

- Guillermo Gomez guillermo.gomezchavez@eviden.com

Asset Owner:

- Sonia Castro sonia.castro@eviden.com

A Gitflow methodology is implemented within this repo. Proceed as follows:

1. Open an Issue, label appropriately and assign to the next planned release.
2. Pull the latest develop and branch off of it with a branch or PR created from GitHub as draft.
3. Commit and push frequently.
4. When ready, set PR as ready, tag team and wait for approval.

## License

ATOS and Eviden Copyright applies. Apache License

```text
/*
 * Copyright 20XX-20XX, Atos Spain S.A.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the copyright holder nor the names of its
 *     contributors may be used to endorse or promote products derived from
 *     this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
```
